/// <reference types="zen-observable" />
import { Operation, ApolloLink, FetchResult, Observable } from 'apollo-link';
export declare function mockSingleLink(...mockedResponses: MockedResponse[]): ApolloLink;
export interface MockedResponse {
    request: any;
    result?: FetchResult;
    error?: Error;
    delay?: number;
}
export declare class MockLink extends ApolloLink {
    private mockedResponsesByKey;
    constructor(mockedResponses: MockedResponse[]);
    addMockedResponse(mockedResponse: MockedResponse): void;
    request(operation: Operation): Observable<FetchResult<Record<string, any>, Record<string, any>>>;
}
